package Conifer::Page;
use 5.010001;
#~ use 5.010;
#~ use feature qw(switch say);
use utf8;
use Mojo::Base 'Mojolicious::Controller';
use Data::Dumper;
use Mojo::ByteStream 'b';
#~ use Mojo::IOLoop;
#~ use Mojo::IOLoop::Trigger;
use AnyEvent;

sub index {
	$|=1;
	my $c = shift;
	my $url = $c->req->url->base.$c->url_for('info-castlist');
	#~ print "URL: $url\n";
	#~ print Dumper ($c->req->url->path);
	#~ print $c->req->url->base;
	
	$c->render_later;
	
	#~ # Parallel non-blocking
	#~ my $t = Mojo::IOLoop->trigger(sub {
		#~ my ($t, @titles) = @_;
			#~ $c->render_json(\@titles);
	#~ });
	#~ for my $url ('http://mojolicio.us', 'https://metacpan.org') {
		#~ $t->begin;
		#~ $c->ua->get($url => sub {
			#~ my ($self, $tx) = @_;
			#~ $t->end($tx->res->dom->html->head->title->text);
		#~ });
	#~ }
	
	#~ # Parallel non-blocking
	#~ my $t = Mojo::IOLoop->trigger(sub {
		#~ my ($t, @results) = @_;
			#~ $c->render(castlist => b($results[0])->decode('UTF-8'));
	#~ });
	#~ my $aecv = AE::cv;
	
	# Get 'info-castlist'
	#~ $t->begin;
	my %results;
	#~ $aecv->begin (sub { shift->send(\%results) });	# Outer CV
	
	#~ $aecv->begin;	# Job CV
	$c->ua->get($url, sub {
		my ($ua, $tx) = @_;
		
		if (my $res_body=$tx->success->body) {
			
			$res_body =~ s/^[\w\W]*(livemain)/<div id="$1/;
			$res_body =~ s/<div id="main">[\w\W]*$//;
			$res_body =~ s{<script[\w\W]+?</script>}{}g;
			$res_body =~ s{<span id="ad_schedule[\w\W]+?</span>}{}g;
			
			$c->render(castlist => b($res_body)->decode('UTF-8'));
			#~ $t->end($res_body);
			#~ $results{'castlist'} = $res_body;
			#~ $aecv->end;
			
		} else {
			warn "failed";
			my ($msg,$error) = $tx->error;
			$c->tx->res->headers->add('X-Remote-Status',$error.': '.$msg);	
			$c->render(
				status => 500,
				text => 'Failed to fetch data from backend'
			);
			#~ $t->end('Failed to fetch data from backend');
			#~ $results{'castlist'} = 'Failed to fetch data from backend';
			#~ $aecv->end;
		}
	});
	
	#~ $aecv->end;	# Outer CV
	#~ $aecv->recv;	# non-blocking wait for all jobs
	
	#~ $c->render(castlist => b($results{'castlist'})->decode('UTF-8'));
}

sub redir_livescore {
	my $c = shift;
	$c->redirect_to('info-livescore');
}

sub admin {
	my $c = shift;
	my $user = $c->session('name');
	
	# Already login
	unless ($user) {
		$c->flash(message => 'Please login first.');
		$c->redirect_to('page-login');
	}
	
	$c->render(motd => "你今天幹勦了嗎？ / Have you Fuck^H^H^Horked somebody today?");	
}

sub login {
	my $c = shift;
	my $user = $c->session('name');
	
	# Already login
	if ($user) {
		$c->flash(message => 'You had logged in already!');
		$c->redirect_to('user-info', name => $user);	# FIXME: redirect to user info
	}
	
	my $motd = "A Fuck A Day, keeps the doctor away.";
	
	$c->render(motd => "$motd", message => "Please Login.");
}

sub logout {
	my $c = shift;
	my $user = $c->session('name');
	
	my $motd = "A Fuck A Day, keeps the doctor away.";
	
	$c->render(motd => "$motd", message => "Are you sure you wanna logout?");
}

sub register {
	my $c = shift;
	my $user = $c->session('name');
	
	# Already login
	if ($user) {
		$c->flash(message => 'You had logged in already!');
		$c->redirect_to('user-info', name => $user);
	}
	
	my $motd = "A Fuck A Day, keeps the doctor away.";
	
	$c->render(motd => "$motd", message => "New user registration.");
}

sub new_article {
	my $c = shift;
	my $user = $c->session('name');
	
	# Already login
	unless ($user) {
		$c->flash(message => 'Please login first.');
		$c->redirect_to('page-login');
	}
	
	my $motd = "A Fuck A Day, keeps the doctor away.";
	
	$c->render(motd => "$motd", who => "$user");
}

sub new_ads {
	my $c = shift;
	my $user = $c->session('name');
	
	# Already login
	unless ($user) {
		$c->flash(message => 'Please login first.');
		$c->redirect_to('page-login');
	}
	
	my $motd = "A Fuck A Day, keeps the doctor away.";
	
	$c->render(motd => "$motd", who => "$user");
}

sub new_board {
	my $c = shift;
	my $user = $c->session('name');
	
	# Already login
	unless ($user) {
		$c->flash(message => 'Please login first.');
		$c->redirect_to('page-login');
	}
	
	my $motd = "A Fuck A Day, keeps the doctor away.";
	
	$c->render(motd => "$motd", who => "$user");
}

sub list {
	# 幹 $whom 的人
	# 對 $whom 的幹
	# $whom 幹的人
	# $whom 的反擊
}

1;
